#!/usr/bin/perl

#	全検索 CGI, Copyright 2013 ◆UOXJ7Oxg.I

# 飛んできた引数をデコードする。
# 検索語は変数 $s に入れることにする。

if ($ENV{'REQUEST_METHOD'} eq 'POST') {
	read (STDIN, $QUERY, $ENV{'CONTENT_LENGTH'});
} else {
	$QUERY = $ENV{'QUERY_STRING'};
}
@PARTS = split (/&/, $QUERY);
foreach (@PARTS) {
	local ($variable, $value) = split(/=/);
	$value =~ tr/+/ /;
	$value =~ s/%([0-9a-fA-F][0-9a-fA-F])/pack("H2", $1)/eg;
#	タグを禁止するには次の二行の # を消す。
#	$value =~ s/</&lt;/g;
#	$value =~ s/>/&gt;/g;
	$VAR{$variable} = $value;
}

$s = $VAR{'search'}; # search という名前は呼び出し元の <input tye="text" name="search" ... に従う。

# 文字を表示するための決まり文句。

print "Content-type: text/html\n\n";

# 検索したいファイルのあるディレクトリを指定。

$dir = "./";

# 上の例では CGI 本体と同じディレクトリ。
# 異なる場所を指定したければ適宜書き換える。

# 上記のディレクトリを開きファイル一覧を得る。

if (opendir DIR, $dir) {
	@files = readdir DIR;
	close DIR;
} else {
# ディレクトリが開けなかった場合のエラーメッセージを表示。
	print "<p>ERROR!</p>";
}

# 検索結果を入れる配列を初期化しておく。

@result = ();

# ファイル一覧の中から必要なものだけを残す。

for ($i = $#files; $i >= 0; $i --) { # 配列を削るので必ず末尾から先頭に向かうようにする。
	splice @files, $i, 1 unless ($files[$i] =~ m/(\.htm|\.html)$/);
# 	この文↑の詳しい解説
#	拡張子が .htm または .html でなければ配列から削除する。
#	ファイル名の条件は m/ / で正規表現で指定。
#	unless なので、その条件に当てはまらないときに左の splice を行う。
#	splice は配列の要素を削除したり置き換えたりする。
}

# 残ったファイルを検索する。
for ($i = 0; $i <= $#files; $i ++) { # 今回は先頭から。
	if (open IN, "<$dir$files[$i]") { # ファイルを開いて読み込む。閉じ忘れ注意。
		read IN, $text, (stat(IN))[7];
		close IN;
		if ($text =~ m/$s/) { # ファイル中に検索文字列があれば結果の配列に追加。
			push @result, $files[$i];
			next;
			# ↑今回はなくても同じことだが、複雑なプログラムになると、条件を満たし次第 next してループを進める癖をつけた方が良い。
		}
	} # ここではエラーコードは吐かない。
}

# ここまでで、検索したい文字列のあるファイル一覧が得られた。あとは結果を表示するだけ。

# 前半を表示。
print <<"_RESULT01_";
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>RESULT</title>
</head>
<body>
<h1>検索結果</h1>
_RESULT01_

# 次に当該ファイルのリンクを作る。

if ($#result >= 0) {
	print "<ul>\n";
	foreach (@result) {
		printf("<li><a href=\"%s%s\">%s</a>\n", $dir, $_, $_);
	}
	print "</ul>\n";
} else {
	print "<p>\"$s\" は見付かりませんでした。</p>\n";
}

# 後半を表示。
print <<"_RESULT02_";
<hr>
<p><a href="./">戻る</a></p>
</body>
</html>
_RESULT02_

# 終了。
__END__
